/*
Copyright Renaud Blanch [http://iihm.imag.fr/blanch/]

This software is a computer program whose purpose is to explore new interaction
techniques for zoomable treemaps.

This software is governed by the CeCILL license under French law and abiding by 
the rules of distribution of free software. You can  use, modify and/ or 
redistribute the software under the terms of the CeCILL license as circulated  
at the following URL [http://www.cecill.info]. 

As a counterpart to the access to the source code and  rights to copy, modify 
and redistribute granted by the license, users are provided only with a limited 
warranty  and the software's author,  the holder of the economic rights,  and 
the successive licensors  have only limited liability. 

The fact that you are presently reading this means that you have had knowledge 
of the CeCILL license and that you accept its terms.
*/

#include <cstdlib>
#include <iostream>
#include <string>
using namespace std;

int main(int argc, char *argv[]) {
	if(argc < 2) {
		cerr << "usage: " << argv[0] << " pattern  < in  > out" << endl;
		return EXIT_FAILURE;
	}

	string topic(argv[1]);
	replace(topic.begin(), topic.end(), ' ', '_');
	string::size_type topic_length(topic.length());
	
	string line;
	while(true) {
		getline(cin, line);
		if(!cin.good()) break;
		
		if(line.rfind(topic, 0) != string::npos) {
			cout << string(line.begin() + topic_length, line.end()) << endl;
		}
	}
	
	return EXIT_SUCCESS;
}
