COPYRIGHT = """
Copyright Renaud Blanch [http://iihm.imag.fr/blanch/]

This software is a computer program whose purpose is to explore new interaction
techniques for zoomable treemaps.

This software is governed by the CeCILL license under French law and abiding by 
the rules of distribution of free software. You can  use, modify and/ or 
redistribute the software under the terms of the CeCILL license as circulated  
at the following URL [http://www.cecill.info]. 

As a counterpart to the access to the source code and  rights to copy, modify 
and redistribute granted by the license, users are provided only with a limited 
warranty  and the software's author,  the holder of the economic rights,  and 
the successive licensors  have only limited liability. 

The fact that you are presently reading this means that you have had knowledge 
of the CeCILL license and that you accept its terms.
"""

import sys
import os

colors = {
	# colors are coded by luminance/alpha
	'o': "0x00, 0xff", # black
	'x': "0xff, 0xff", # white
	' ': "0x00, 0x00", # transparent
	'O': "0x00, 0xff", # black hotspot
	'X': "0xff, 0xff", # white hotspot
	'H': "0x00, 0x00"  # transparent hotspot
}
          
def xo2h(name="image"):
	lines = [line.rstrip() for line in sys.stdin]
	width = max([len(line) for line in lines])	
	height = len(lines)
	x_hot, y_hot = 0, 0
	for y, line in enumerate(lines):
		for x, c in enumerate(line):
			if c in "OXH":
				x_hot, y_hot = x, y
				break
	
	print "// file generated by xo2h.py"
	print
	print "// raw input data:"
	print "/*" + "*" * (width - 2)
	print '\n'.join(lines)
	print "*" * (width - 2) + "*/"
	print

	# producing word aligned datas	
	m4 = width % 4
	if m4 != 0: width += (4 - m4)

	print "// image size & hotspot"
	print "#define %s_width  %i" % (name, width)
	print "#define %s_height %i" % (name, height)
	print "#define %s_x_hot %i" % (name, x_hot)
	print "#define %s_y_hot %i" % (name, y_hot)
	print

#	lines.reverse()
	lines = [line.ljust(width) for line in lines]
	lines = ["\t%s" % ", ".join([colors[c] for c in line]) for line in lines]
	
	print "// luminance/alpha data"
	print "static unsigned char %s_luminance_alpha[] = {" % name
	print ",\n".join(lines)	
	print "};"
	
	
if __name__ == "__main__":
	filenames = sys.argv[1:]
	if filenames == []:
		xo2h()
	else:
		for filename in filenames:
			sys.stdin = open(filename)
			root, _ = os.path.splitext(filename)
			sys.stdout = open(root + ".h", "w")
			name = os.path.basename(root)
			xo2h(name)
			sys.stdin.close()
			sys.stdout.close()
		sys.stdin  = sys.__stdin__
		sys.stdout = sys.__stdout__
